// ================================================================
//  jkl-parsexml.js ---- XML Ľ  ڹ ũƮ  ̺긮
//  Copyright 2005 Kawasaki Yusuke <u-suke@kawa.net>
// ================================================================
//  v0.01  2005/05/18  ù 
//  v0.02  2005/05/20  Opera 8.0beta  
//  v0.03  2005/05/20  overrideMimeType( "text/xml" );
//  v0.04  2005/05/21  Ŭ : REQUEST_TYPE, RESPONSE_TYPE
//  v0.05  2005/05/22  IE 6 GET ޼ҵ带  Msxml2.DOMDocument.5.0 
//  v0.06  2005/05/22  CDATA_SECTION_NODE
//  v0.07  2005/05/23  IE 6 GET ޼ҵ带  Microsoft.XMLDOM 
// ================================================================

if ( typeof(JKL) == 'undefined' ) JKL = function() {};

//  JKL.ParseXML 

JKL.ParseXML = function ( url, query ) {
    // debug.print( "new JKL.ParseXML( '"+url+"', '"+query+"' );" );
    this.url    = url;
    this.method = ( typeof(query) == "string" ) ? "POST" : "GET";
    this.query  = ( typeof(query) == "string" ) ? query : null;
    this.async_done = false;
    return this;
};

//  Ŭ 

JKL.ParseXML.MAP_NODETYPE = [
    "",
    "ELEMENT_NODE",                 // 1
    "ATTRIBUTE_NODE",               // 2
    "TEXT_NODE",                    // 3
    "CDATA_SECTION_NODE",           // 4
    "ENTITY_REFERENCE_NODE",        // 5
    "ENTITY_NODE",                  // 6
    "PROCESSING_INSTRUCTION_NODE",  // 7
    "COMMENT_NODE",                 // 8
    "DOCUMENT_NODE",                // 9
    "DOCUMENT_TYPE_NODE",           // 10
    "DOCUMENT_FRAGMENT_NODE",       // 11
    "NOTATION_NODE"                 // 12
];

JKL.ParseXML.REQUEST_TYPE  = "application/x-www-form-urlencoded";
JKL.ParseXML.RESPONSE_TYPE = "text/xml";
JKL.ParseXML.ACTIVEX_XMLDOM  = "Microsoft.XMLDOM";  // Msxml2.DOMDocument.5.0
JKL.ParseXML.ACTIVEX_XMLHTTP = "Microsoft.XMLHTTP"; // Msxml2.XMLHTTP.3.0

//   Լ  (ajax)

JKL.ParseXML.prototype.async = function ( func, args ) {
    this.callback_func = func;       // ݹ Լ
    this.callback_arg  = args;       // ù° μ
};

JKL.ParseXML.prototype.onerror = function ( func, args ) {
    this.onerror_func = func;       // ݹ Լ
};

//   ڽ 迭
JKL.ParseXML.prototype.setOutputArrayAll = function () {
    this.setOutputArray( true );
}
//  ڽ ϳ Į, ټ ڽ 迭
JKL.ParseXML.prototype.setOutputArrayAuto = function () {
    this.setOutputArray( null );
}
//   ڽ Į (ù )
JKL.ParseXML.prototype.setOutputArrayNever = function () {
    this.setOutputArray( false );
}
//   ڽ 迭,  ڽ Į
JKL.ParseXML.prototype.setOutputArrayElements = function ( list ) {
    this.setOutputArray( list );
}
//  ڽ  Į󡤹迭 ٷ 
JKL.ParseXML.prototype.setOutputArray = function ( mode ) {
    if ( typeof(mode) == "string" ) {
        mode = [ mode ];                // ڿ 迭
    }
    if ( mode && typeof(mode) == "object" ) {
        if ( mode.length < 0 ) {
            mode = false;               // 迭 [] false 
        } else {
            var hash = {};
            for( var i=0; i<mode.length; i++ ) {
                hash[mode[i]] = true;
            }
            mode = hash;                // 迭 ؽ 迭
            if ( mode["*"] ) {
                mode = true;            // "*" ϸ true
            }
        } 
    } 
    this.usearray = mode;
}

//   XML   ޾ ĽѴ

JKL.ParseXML.prototype.parse = function () {

    var http = new JKL.ParseXML.HTTP( this.method );
    // debug.print( "JKL.ParseXML.HTTP: "+http );
    if ( ! http ) return;

    if ( this.onerror_func ) http.onerror = this.onerror_func;

    if ( this.callback_func ) {                             // 񵿱 
        var copy = this;
        var proc = function() {
            var dom = http.documentElement();
            var d2j = new JKL.ParseXML.JSON( copy.usearray );
            var json = d2j.parseDocument( dom );
            copy.callback_func( json, copy.callback_arg );  // ݹ
        };
        http.load( this.url, this.query, proc );
    } else {                                                //  
        http.load( this.url, this.query, null );
        var dom = http.documentElement();
        var d2j = new JKL.ParseXML.JSON( this.usearray );
        var json = d2j.parseDocument( dom );
        return json;
    }
};

// ================================================================

JKL.ParseXML.HTTP = function( method ) {
    this.req = null;
    this.method = method;
    this.xmlhttp = false;
    this.xmldom = false;
    this.onerror = null;

    if ( window.ActiveXObject ) {
        if ( method == "GET" ) {                    // IE GET
            // debug.print( 'new ActiveXObject( "'+JKL.ParseXML.ACTIVEX_XMLDOM+'" )' );
            this.req = new ActiveXObject( JKL.ParseXML.ACTIVEX_XMLDOM );
            if ( this.req ) this.xmldom = true;
        } else {                                    // IE POST
            // debug.print( 'new ActiveXObject( "'+JKL.ParseXML.ACTIVEX_XMLHTTP+'" )' );
            this.req = new ActiveXObject( JKL.ParseXML.ACTIVEX_XMLHTTP );
            if ( this.req ) this.xmlhttp = true;
        }
//  } else if ( method == "GET" &&
//              document.implementation && 
//              document.implementation.createDocument ) {
//      // debug.print( "document.implementation.createDocument()" );
//      this.req = document.implementation.createDocument("", "", null);
//      if ( this.req ) this.xmldom = true;
    } else if ( window.XMLHttpRequest ) {           // Firefox, Opera
        // debug.print( "new XMLHttpRequest()" );
        this.req = new XMLHttpRequest();
        if ( this.req ) this.xmlhttp = true;
    }
    return this;
};

JKL.ParseXML.HTTP.prototype.load = function( url, query, func ) {

    // ݹ Լ Ǿ  񵿱
    var async = func ? true : false;
    // debug.print( "async: "+ async );

    if ( this.xmlhttp ) {
        // 
        // debug.print( "open( '"+this.method+"', '"+url+"', "+async+" );" );
        this.req.open( this.method, url, async );

        //  Content-Type: text/xml ()
        if ( typeof(this.req.overrideMimeType) != "undefined" ) {
            // debug.print( "Content-Type: "+JKL.ParseXML.RESPONSE_TYPE+" (response)" );
            this.req.overrideMimeType( JKL.ParseXML.RESPONSE_TYPE );
        }

        // û Content-Type: application/x-www-form-urlencoded
        if ( typeof(this.req.setRequestHeader) != "undefined" ) {
            // debug.print( "Content-Type: "+JKL.ParseXML.REQUEST_TYPE+" (request)" );
            this.req.setRequestHeader("content-type", JKL.ParseXML.REQUEST_TYPE );
        }
    }

    // 񵿱   ݹ ڵ巯 
    if ( async ) {
        var copy = this;
        copy.already_done = false;                  //  Ľ ȵǾ
        var callback = function () {
            if ( copy.req.readyState != 4 ) return;
            // debug.print( "readyState: "+copy.req.readyState );
            if ( copy.xmlhttp ) {
                // debug.print( "status: "+copy.req.status+" (async mode)" );
                if ( copy.req.status != 200 && copy.req.status != 304 ) {
                    if ( copy.onerror ) copy.onerror( copy.req.status );
                    return;
                }
            }
            if ( copy.xmldom ) {
                // Microsoft.XMLDOM Ľ 
                if ( copy.req.parseError && copy.req.parseError.errorCode != 0 ) {
                    // debug.print( "parseError: "+copy.req.parseError.reason );
                    if ( copy.onerror ) copy.onerror( copy.req.parseError.reason );
                    return;
                }
            }
            if ( copy.already_done ) return;        //  ѹ Ľ
            copy.already_done = true;               // ̹Ľ̵
            func();                                 // ݹ
        };
        this.req.onreadystatechange = callback;
        // this.req.onload = func;  // document.implementation.createDocument
    }

    if ( this.xmldom ) {
        this.req.async = async;

        // û  ڿ 
        // debug.print( "load( '"+url+"' );" );
        this.req.load( url );
    }

    if ( this.xmlhttp ) {
        // û  ڿ 
        // debug.print( "send( '"+query+"' );" );
        this.req.send( query );
    }

    // 񵿱   ׳ Ѵ
    if ( async ) return;

    if ( this.xmldom ) {
        // Microsoft.XMLDOM Ľ 
        if ( this.req.parseError && this.req.parseError.errorCode != 0 ) {
            // debug.print( "parseError: "+this.req.parseError.reason );
            if ( this.onerror ) this.onerror( this.req.parseError.reason );
            return;
        }
    }

    if ( this.xmlhttp ) {
        // debug.print( "status: "+this.req.status+" (sync mode)" );
        if ( this.req.status != 200 && this.req.status != 304 ) {
            if ( this.onerror ) this.onerror( this.req.parseError.reason );
            return;
        }
    }
}

JKL.ParseXML.HTTP.prototype.documentElement = function() {
    if ( ! this.req ) return;
    if ( this.xmlhttp && this.req.responseXML ) {
        return this.req.responseXML.documentElement;
    }
    if ( this.xmldom ) {
        return this.req.documentElement;
    }
}

// ================================================================

JKL.ParseXML.JSON = function( usearray ) {
    this.usearray = usearray;
    return this;
}

//  DOM JSON ȯѴ 

JKL.ParseXML.JSON.prototype.parseDocument = function ( root ) {
    // debug.print( "parseDocument: "+root );
    if ( ! root ) return;

    var ret = this.parseElement( root );            // Ʈ  Ľ
    // debug.print( "parsed: "+ret );

    if ( this.usearray == true ) {                  //  迭
        ret = [ ret ];
    } else if ( this.usearray == false ) {          //  Į
        //
    } else if ( this.usearray == null ) {           // ڵ
        //
    } else if ( this.usearray[root.nodeName] ) {    //  ±
        ret = [ ret ];
    }

    var json = {};
    json[root.nodeName] = ret;                      // Ʈ  ̸
    return json;
};

//  DOM JSON ٲ۴ 

JKL.ParseXML.JSON.prototype.parseElement = function ( elem ) {
    // debug.print( "nodeType: "+JKL.ParseXML.MAP_NODETYPE[elem.nodeType]+" <"+elem.nodeName+">" );

    //  COMMENT_NODE

    if ( elem.nodeType == 7 ) {
        return;
    }

    //  TEXT_NODE CDATA_SECTION_NODE

    if ( elem.nodeType == 3 || elem.nodeType == 4 ) {
        var bool = elem.nodeValue.match( /[^\u0000-\u0040]/ );
        if ( bool == null ) return;     // ignore white spaces
        // debug.print( "TEXT_NODE: "+elem.nodeValue.length+ " "+bool );
        return elem.nodeValue;
    }

    var retval;
    var cnt = {};

    //  Ӽ ĽѴ

    if ( elem.attributes && elem.attributes.length ) {
        retval = {};
        for ( var i=0; i<elem.attributes.length; i++ ) {
            var key = elem.attributes[i].nodeName;
            if ( typeof(key) != "string" ) continue;
            var val = elem.attributes[i].nodeValue;
            if ( ! val ) continue;
            if ( typeof(cnt[key]) == "undefined" ) cnt[key] = 0;
            cnt[key] ++;
            this.addNode( retval, key, cnt[key], val );
        }
    }

    //  ڽ 带 ĽѴ(ȸ)

    if ( elem.childNodes && elem.childNodes.length ) {
        var textonly = true;
        if ( retval ) textonly = false;        // Ӽ Ѵ
        for ( var i=0; i<elem.childNodes.length && textonly; i++ ) {
            var ntype = elem.childNodes[i].nodeType;
            if ( ntype == 3 || ntype == 4 ) continue;
            textonly = false;
        }
        if ( textonly ) {
            if ( ! retval ) retval = "";
            for ( var i=0; i<elem.childNodes.length; i++ ) {
                retval += elem.childNodes[i].nodeValue;
            }
        } else {
            if ( ! retval ) retval = {};
            for ( var i=0; i<elem.childNodes.length; i++ ) {
                var key = elem.childNodes[i].nodeName;
                if ( typeof(key) != "string" ) continue;
                var val = this.parseElement( elem.childNodes[i] );
                if ( ! val ) continue;
                if ( typeof(cnt[key]) == "undefined" ) cnt[key] = 0;
                cnt[key] ++;
                this.addNode( retval, key, cnt[key], val );
            }
        }
    }
    return retval;
};

JKL.ParseXML.JSON.prototype.addNode = function ( hash, key, cnts, val ) {
    if ( this.usearray == true ) {              // 迭
        if ( cnts == 1 ) hash[key] = [];
        hash[key][hash[key].length] = val;      // ֱ
    } else if ( this.usearray == false ) {      // Į
        if ( cnts == 1 ) hash[key] = val;       // ù° 
    } else if ( this.usearray == null ) {
        if ( cnts == 1 ) {                      // ù 
            hash[key] = val;
        } else if ( cnts == 2 ) {               // ι° 
            hash[key] = [ hash[key], val ];
        } else {                                // °   
            hash[key][hash[key].length] = val;
        }
    } else if ( this.usearray[key] ) {
        if ( cnts == 1 ) hash[key] = [];
        hash[key][hash[key].length] = val;      // ֱ
    } else {
        if ( cnts == 1 ) hash[key] = val;       // ù° 
    }
};

// ================================================================
// http://msdn.microsoft.com/library/en-us/xmlsdk/html/d051f7c5-e882-42e8-a5b6-d1ce67af275c.asp
// ================================================================
